## iwrite-2.0.1.0.tar.gz

=== Makefile ===
# vim:noexpandtab:softtabstop=2:tabstop=2:shiftwidth=2:nowrap
# 
# Copyright (c) 2015-2016, iwrite authors
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
# 1. Redistributions of source code must retain the above copyright notice,
# this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

.SILENT:

UNAME:= $(shell uname)
BITS:= $(shell uname -m)

ifndef prefix
	ifeq ($(UNAME), OpenBSD)
		prefix=/usr/local
	else ifeq ($(UNAME), FreeBSD)
		prefix=/usr/local
	else ifeq ($(UNAME), NetBSD)
		prefix=/usr/pkg
	else
		prefix=/usr
	endif
endif

ifndef BINDIR
	BINDIR=${prefix}/bin
endif

ifndef LIBDIR
	LIBDIR=${prefix}/lib

	ifeq ($(UNAME), Linux)
		ifeq ($(BITS), x86_64)
			LIBDIR=${prefix}/lib64
		endif
	endif
endif

ifndef DATADIR
	DATADIR=${prefix}/share/iwrite
endif

UIDIR=${DATADIR}/ui

ifndef DOCDIR
	DOCDIR=${prefix}/share/doc/iwrite
endif

ifeq ($(UNAME), Linux)
	CFGFILE=data/iwrite_driver.cfg_linux
else ifeq ($(UNAME), NetBSD)
	CFGFILE=data/iwrite_driver.cfg_netbsd
else
	CFGFILE=data/iwrite_driver.cfg_bsd
endif

#CFGDIR=`echo ${XDG_CONFIG_DIRS} | cut -d ":" -f 1`
ifeq ($(UNAME), NetBSD)
	CFGDIR=${prefix}/etc/xdg
else
	CFGDIR=/etc/xdg
endif

.PHONY: all
all: docs iwrite drivers

.PHONY: docs
docs: doc/iwrite.pdf
	@echo finished documentation

doc/iwrite.pdf:
	@cd doc && ${MAKE}

.PHONY: iwrite
iwrite: src/iwrite
	@echo finished iwrite

src/iwrite: 
	@cd src && ${MAKE}

.PHONY: drivers
ifeq ($(UNAME), Linux)
drivers:\
	drivers/postgres/libiwsql_pq.so \
	drivers/mariadb/libiwsql_mariadb.so \
	drivers/sqlite3/libiwsql_sqlite3.so \
	drivers/oracle/libiwsql_oracle.so
else
drivers:\
	drivers/postgres/libiwsql_pq.so \
	drivers/mariadb/libiwsql_mariadb.so \
	drivers/sqlite3/libiwsql_sqlite3.so
endif
	@echo finished database drivers

drivers/postgres/libiwsql_pq.so: 
	@cd drivers && ${MAKE} postgres

drivers/mariadb/libiwsql_mariadb.so:
	@cd drivers && ${MAKE} mariadb

drivers/sqlite3/libiwsql_sqlite3.so:
	@cd drivers && ${MAKE} sqlite3

drivers/oracle/libiwsql_oracle.so:
	@cd drivers && ${MAKE} oracle

.PHONY: clean
clean:
	@echo making clean
	cd drivers && ${MAKE} clean
	cd src/decNumber && ${MAKE} clean
	cd src/icu && ${MAKE} clean
	cd src/ruler && ${MAKE} clean
	cd src/geometry && ${MAKE} clean
	cd src/zint && ${MAKE} clean
	cd src && ${MAKE} clean

.PHONY: install
install:
	@echo installing iwrite
	test -d ${DESTDIR}${BINDIR} || mkdir -p ${DESTDIR}${BINDIR}
	test -d ${DESTDIR}${LIBDIR} || mkdir -p ${DESTDIR}${LIBDIR}
	test -d ${DESTDIR}${CFGDIR} || mkdir -p ${DESTDIR}${CFGDIR}
	test -d ${DESTDIR}${DOCDIR} || mkdir -p ${DESTDIR}${DOCDIR}
	test -d ${DESTDIR}${DATADIR} || mkdir -p ${DESTDIR}${DATADIR}
	test -d ${DESTDIR}${UIDIR} || mkdir -p ${DESTDIR}${UIDIR}
	install -s -m 0655 src/iwrite ${DESTDIR}${BINDIR}/iwrite
	install -s -m 0755 drivers/postgres/libiwsql_pq.so ${DESTDIR}${LIBDIR}/libiwsql_pq.so 
	install -s -m 0755 drivers/mariadb/libiwsql_mariadb.so ${DESTDIR}${LIBDIR}/libiwsql_mariadb.so 
	install -s -m 0755 drivers/sqlite3/libiwsql_sqlite3.so ${DESTDIR}${LIBDIR}/libiwsql_sqlite3.so 
ifeq ($(UNAME), Linux)
	install -s -m 0755 drivers/oracle/libiwsql_oracle.so ${DESTDIR}${LIBDIR}/libiwsql_oracle.so 
endif
	install -m 0644 ${CFGFILE} ${DESTDIR}${CFGDIR}/iwrite_driver.cfg
	install -m 0444 README ${DESTDIR}${DOCDIR}/README
	install -m 0444 COPYING ${DESTDIR}${DOCDIR}/COPYING
	install -m 0444 doc/iwrite.pdf ${DESTDIR}${DOCDIR}/iwrite.pdf
	install -m 0644 src/break.glade ${DESTDIR}${UIDIR}/break.glade
	install -m 0644 src/circle.glade ${DESTDIR}${UIDIR}/circle.glade
	install -m 0644 src/database.glade ${DESTDIR}${UIDIR}/database.glade
	install -m 0644 src/date.glade ${DESTDIR}${UIDIR}/date.glade
	install -m 0644 src/export.glade ${DESTDIR}${UIDIR}/export.glade
	install -m 0644 src/export_page_setup.glade ${DESTDIR}${UIDIR}/export_page_setup.glade
	install -m 0644 src/fbarcode.glade ${DESTDIR}${UIDIR}/fbarcode.glade
	install -m 0644 src/field.glade ${DESTDIR}${UIDIR}/field.glade
	install -m 0644 src/fimage.glade ${DESTDIR}${UIDIR}/fimage.glade
	install -m 0644 src/fnumber.glade ${DESTDIR}${UIDIR}/fnumber.glade
	install -m 0644 src/frame.glade ${DESTDIR}${UIDIR}/frame.glade
	install -m 0644 src/fsum.glade ${DESTDIR}${UIDIR}/fsum.glade
	install -m 0644 src/ftext.glade ${DESTDIR}${UIDIR}/ftext.glade
	install -m 0644 src/image.glade ${DESTDIR}${UIDIR}/image.glade
	install -m 0644 src/label_page_setup.glade ${DESTDIR}${UIDIR}/label_page_setup.glade
	install -m 0644 src/line.glade ${DESTDIR}${UIDIR}/line.glade
	install -m 0644 src/mainwindow.glade ${DESTDIR}${UIDIR}/mainwindow.glade
	install -m 0644 src/page_number.glade ${DESTDIR}${UIDIR}/page_number.glade
	install -m 0644 src/query.glade ${DESTDIR}${UIDIR}/query.glade
	install -m 0644 src/README.glade ${DESTDIR}${UIDIR}/README
	install -m 0644 src/runreport.glade ${DESTDIR}${UIDIR}/runreport.glade
	install -m 0644 src/scrollwin.glade ${DESTDIR}${UIDIR}/scrollwin.glade
	install -m 0644 src/text.glade ${DESTDIR}${UIDIR}/text.glade

.PHONY: uninstall
uninstall:
	@echo uninstalling iwrite
	@rm -f ${DESTDIR}${BINDIR}/iwrite
	@rm -f ${DESTDIR}${LIBDIR}/libiwsql_pq.so 
	@rm -f ${DESTDIR}${LIBDIR}/libiwsql_mariadb.so 
	@rm -f ${DESTDIR}${LIBDIR}/libiwsql_sqlite3.so 
	@rm -f ${DESTDIR}${LIBDIR}/libiwsql_oracle.so 
	@rm -f ${DESTDIR}${CFGDIR}/iwrite_driver.cfg
	@rm -rf ${DESTDIR}${DOCDIR}
	@rm -rf ${DESTDIR}${DATADIR}

=== src/Makefile ===
# vim:noexpandtab:softtabstop=2:tabstop=2:shiftwidth=2:nowrap
# 
# Copyright (c) 2015-2016, iwrite authors
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
# 1. Redistributions of source code must retain the above copyright notice,
# this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

UNAME:= $(shell uname)

ifeq ($(UNAME), Linux)
LDFLAGS+= -ldl -lX11
PNG_LIB= -l png
else
LDFLAGS+= -Wl,-R/usr/X11R7/lib
PNG_LIB= -l png16
endif

ifeq ($(UNAME), FreeBSD)
LDFLAGS+= -lX11
endif

# use icu-config?
ICU4=`pkg-config --cflags icu-uc icu-io`
ICU4_LIB=`pkg-config --libs icu-uc icu-io`

GTK=`pkg-config gtk+-3.0 --cflags`
GTK_LIB=`pkg-config gtk+-3.0 --libs`

GMODULE=`pkg-config gmodule-export-2.0 --cflags`
GMODULE_LIB=`pkg-config gmodule-export-2.0 --libs`

ICU=-I icu/
ICU_LIB=-L icu/ -licu

DECN=-I decNumber/
DECN_LIB=-L decNumber/ -ldecnumber

IWSQL_DRIVER=-I../drivers/include

GEOM=-I geometry/
GEOM_LIB=-L geometry/ -lgeometry

ZINT=-I zint/
ZINT_LIB=zint/libzint.a ${PNG_LIB}

ZLIB=`pkg-config --cflags zlib`
ZLIB_LIB=`pkg-config --libs zlib`

CFLAGS=\
	${IWSQL_DRIVER}\
	${GTK}\
	${ICU}\
	${DECN}\
	${RULER}\
	${GEOM}\
	${GMODULE}\
	${ZINT}\
	${ZLIB}\
	-pthread\
	-Wall\
	-std=c99\
	-pedantic\
	-ggdb

CXXFLAGS:=${CFLAGS}

ALL_LIB=\
	${GTK_LIB}\
	${ICU4_LIB}\
	${ICU_LIB}\
	${DECN_LIB}\
	${RULER_LIB}\
	${GEOM_LIB}\
	${GMODULE_LIB}\
	${ZINT_LIB}\
	${ZLIB_LIB}\
	${LDFLAGS}\
	-lstdc++\
	-lm\

IWRITE_OBJECTS=\
	database_aspect.o\
	database_aspect_property.o\
	database_config.o\
	database_field.o\
	database_field_property.o\
	database_session.o\
	driver_config.o\
	error.o\
	export_config.o\
	export_csv.o\
	export.o\
	export_page_setup_property.o\
	export_spec.o\
	global_common.o\
	item_circle.o\
	item_circle_property.o\
	item_common_base.o\
	item_common_box.o\
	item_common_circle.o\
	item_common_line.o\
	item_common_lookup.o\
	item_common_rectvect.o\
	item_date.o\
	item_date_property.o\
	item_fbarcode.o\
	item_fbarcode_property.o\
	item_fimage.o\
	item_fimage_property.o\
	item_fnumber.o\
	item_fnumber_property.o\
	item_frame.o\
	item_frame_property.o\
	item_fsum.o\
	item_fsum_property.o\
	item_ftext.o\
	item_ftext_property.o\
	item_image.o\
	item_image_property.o\
	item_line.o\
	item_line_property.o\
	item.o\
	item_page_number.o\
	item_page_number_property.o\
	item_text.o\
	item_text_property.o\
	iwr_page_menu.o\
	iwr_page.o\
	iwsql_dll.o\
	label.o\
	label_page_setup_property.o\
	label_paper.o\
	label_pdf.o\
	label_spec.o\
	layout_break_property.o\
	layout_division.o\
	layout.o\
	layout_page_setup_property.o\
	layout_pdf.o\
	layout_spec.o\
	main.o\
	mainw.o\
	menu.o\
	option.o\
	page_setup.o\
	page_setup_property.o\
	paper.o\
	pixbuf.o\
	query_exec.o\
	query.o\
	query_property.o\
	report.o\
	report_util.o\
	rw.o\
	sql.o\
	symbology.o\
	version.o\
	xml.o

includes = ${wildcard *.h}

.PHONY: all
all: icu/libicu.a decNumber/libdecnumber.a\
	geometry/libgeometry.a zint/libzint.a iwrite

iwrite : ${IWRITE_OBJECTS}
	${CC} -o $@ ${IWRITE_OBJECTS} ${ALL_LIB} 

%.o : %.c ${includes}
	${CC} -c ${CFLAGS} -o $@ $< 2> $@.err

item_common_lookup.o: item_common_lookup_gp.c

item_common_lookup_gp.c: item_common_lookup.gperf
	gperf -7 -D -t -L 'ANSI-C' item_common_lookup.gperf --output-file=item_common_lookup_gp.c

icu/libicu.a:
	@cd icu && ${MAKE}

decNumber/libdecnumber.a:
	@cd decNumber && ${MAKE}

geometry/libgeometry.a:
	@cd geometry && ${MAKE}

zint/libzint.a:
	@cd zint && ${MAKE}

clean:
	rm -f *.o
	rm -f *.o.err
	rm -f *.a
	rm -f *.so
	rm -f iwrite

=== drivers/sqlite3/Makefile ===
# vim:noexpandtab:softtabstop=2:tabstop=2:shiftwidth=2:nowrap
# Copyright (c) 2015, iwrite authors
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
# 1. Redistributions of source code must retain the above copyright notice,
# this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

RANLIB=ranlib

INC=-I../include -I./amalgamation

CFLAGS+=-fPIC -Wall -pedantic -ggdb ${INC}

OBJECTS=\
	./amalgamation/sqlite3.o\
	iwsql_attr_delete.o\
	iwsql_connect.o\
	iwsql_delete.o\
	iwsql_error_code.o\
	iwsql_exec.o\
	iwsql_new.o\
	iwsql_next.o\
	iwsql_result.o

includes = ${wildcard *.h}

.PHONY: libs
libs: libiwsql_sqlite3.so libiwsql_sqlite3.a

libiwsql_sqlite3.so: ${OBJECTS}
	${CC} -shared -o $@ $?

libiwsql_sqlite3.a: ${OBJECTS}
	${AR} rvc $@ $? 
	${RANLIB} $@

%.o : %.c ${includes}
	${CC} -c ${CFLAGS} -o $@ $< 2> $@.err

./amalgamation/sqlite3.o: amalgamation/sqlite3.c amalgamation/sqlite3.h amalgamation/sqlite3ext.h
	cd amalgamation && ${MAKE}

clean:
	rm -f *.o
	rm -f *.o.err
	rm -f *.a
	rm -f *.so
	@cd amalgamation && ${MAKE} clean

=== src/GtkWidgetSkeleton/Makefile ===
# vim:noexpandtab:softtabstop=2:tabstop=2:shiftwidth=2:nowrap
#  CC0 1.0 Universal (CC0 1.0) Public Domain Dedication
#
# Deriviative works may remove this license dedication and incorporate
# their own.
# 
# GTK widget skeleton template

RANLIB=ranlib

GLIB=`pkg-config glib-2.0 --cflags`
GLIB_LIB=`pkg-config glib-2.0 --libs`

GTK=`pkg-config gtk+-3.0 --cflags`
GTK_LIB=`pkg-config gtk+-3.0 --libs`

includes = ${wildcard *.h}

CFLAGS=\
	${GLIB}\
	${GTK}\
	-pthread\
	-Wall\
	-ansi\
	-pedantic\
	-ggdb

LIBSKEL_OBJECTS=\
	skel.o

libskel.a: ${LIBSKEL_OBJECTS}
	${AR} rvc $@ $?
	${RANLIB} $@

%.o : %.c ${includes}
	${CC} -c ${CFLAGS} -o $@ $< 2> $@.err

clean:
	rm -f *.o
	rm -f *.o.err
	rm -f *.a
	rm -f *.so

=== packaging/debian/changelog ===
iwrite (2.0.1.0-1) unstable; urgency=low

  * Use XML instead of BSON

 -- Mark Olesen <markjolesen@gmail.com>  Fri, 12 Feb 2016 01:10:17 -0700

iwrite (1.0.1.4-1) unstable; urgency=low

  * Initial beta release.

 -- Mark Olesen <markjolesen@gmail.com>  Tue, 12 Jan 2016 01:22:49 -0700

=== packaging/abs/PKGBUILD ===
pkgname=iwrite
pkgver=2.0.1.0
pkgrel=1
pkgdesc=('SQL report writer')
arch=('i686' 'x86_64')
url=('http://www.nongnu.org/iwrite/')
license=('BSD')
depends=('icu' 'gtk3')
# makedepends need to add postgres mariadb or mysql client + oracle client libs
source=(
"http://download.savannah.gnu.org/releases/iwrite/$pkgname-$pkgver.tar.gz"
"http://download.savannah.gnu.org/releases/iwrite/$pkgname-$pkgver.tar.gz.sig"
)

md5sums=('SKIP' 'SKIP')


build() {
  cd "$srcdir/$pkgname-$pkgver"
  make
}

package() {
  cd "$srcdir/$pkgname-$pkgver"
  make DESTDIR="$pkgdir" LIBDIR=/usr/lib install
}
